﻿//
// Copyright (c) 2013, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Media;

namespace DrillDownChart
{
    public class Expenses : INotifyPropertyChanged
    {
        private string corporationName;
        private double marketing;
        private double salaries;
        private double rawMaterials;
        private double logistics;
        private double administration;
        private double production;
        private double sum;
        private DoubleCollection expensesList;
    
     
        public event PropertyChangedEventHandler PropertyChanged;    

        public Expenses(string corporationName, double marketing, double salaries, 
            double rawMaterials, double logistics, double administration, double production)
        {
            this.corporationName = corporationName;
            this.marketing = marketing;
            this.salaries = salaries;
            this.rawMaterials = rawMaterials;
            this.logistics = logistics;
            this.administration = administration;
            this.production = production;
          
            expensesList = new DoubleCollection();
            expensesList.Add(marketing);
            expensesList.Add(salaries);
            expensesList.Add(rawMaterials);
            expensesList.Add(logistics);
            expensesList.Add(administration);
            expensesList.Add(production);
            this.sum =  marketing + salaries + rawMaterials +
                logistics + administration + production;
      }


        public override string ToString()
        {
            return corporationName.ToString();
        }

        public string CorporationName
        {
            get { return corporationName; }
            set
            {
                corporationName = value;
                OnPropertyChanged("CorporationName");
            }
        }

        public double Marketing
        {
            get { return marketing; }
            set
            {
                marketing = value;
                OnPropertyChanged("Marketing");
            }
        }

        public double Salaries
        {
            get { return salaries; }
            set
            {
                salaries = value;
                OnPropertyChanged("Salaries");
            }
        }

        public double RawMaterials
        {
            get { return rawMaterials; }
            set
            {
                rawMaterials = value;
                OnPropertyChanged("RawMaterials");
            }
        }

        public double Logistics
        {
            get { return logistics; }
            set
            {
                logistics = value;
                OnPropertyChanged("Logistics");
            }
        }

        public double Administration
        {
            get { return administration; }
            set
            {
                administration = value;
                OnPropertyChanged("Administration");
            }
        }

        public double Production
        {
            get { return production; }
            set
            {
                administration = value;
                OnPropertyChanged("Administration");
            }
        }

        public DoubleCollection ExpensesList
        {
            get { return expensesList; }
            set 
            { 
                expensesList = value;
                OnPropertyChanged("ExpensesList");
            }
        }

       
        public double Sum
        {
            get { return sum; }
            set
            {
                sum = value;
                OnPropertyChanged("Sum");
            }
        }


        protected void OnPropertyChanged(string info)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class CompanyExpenses : ObservableCollection<Expenses>
    {
        public CompanyExpenses()
            : base()
        {
            Add(new Expenses("Limerat Corp.", 23, 45, 12, 33, 40, 18));
            Add(new Expenses("Chillybit LLC", 18, 45, 67, 81, 20, 31));
            Add(new Expenses("Streamverti S.A.R.L.", 9, 31, 42, 50, 62, 9));
            Add(new Expenses("Gaprex Corp.", 21, 43, 51, 68, 78, 82 ));
            Add(new Expenses("Wideunit Ltd.",  13, 34, 56, 21, 10, 7));
          
      }
    }
}
